classdef SampleBuffer < handle
    %Delays samples by the specified buffer count
    
    properties(Access = private)
        buffer = nan(0,0);
        delay = 0;
        count {uint64} = 0;
    end
    
    methods
        function [] = setDelay(this, sampleDelay)
            this.delay = uint32(sampleDelay);
            this.buffer = nan(sampleDelay + 1, 1);
            this.count = 0;
        end
        
        function index = getIndex(this, sampleIx)
            index = mod(sampleIx, length(this.buffer)) + 1;
        end
        
        function delayedSample = update(this, newSample)
            this.count = this.count + 1;
            newIx = this.getIndex(this.count);
            oldIx = this.getIndex(this.count - this.delay);
            
            this.buffer(newIx) = newSample;
            delayedSample = this.buffer(oldIx);
        end
    end
end

