%% Open the video stream file using memory mapping
% The file gets created by the stream acquiring process
stream = mapVideoStream('cam0.stream');
disp(['Found ' num2str(stream.Data.width) 'x' num2str(stream.Data.height) ' image']);

%% Set rotation w/ delay
% Typically sensors used to estimate rotation have a lower latency
% than the video feed, so the rotation needs to be artificially delayed 
% to match. The simplest way to do it is a sample based buffer that
% delays by a fixed number of samples, e.g., 5 samples = 50ms delay at
% 100Hz.
rotation = SampleBuffer();
rotation.setDelay(5);

% Set the value in shared memory
for i = 0:0.02:2*pi
    stream.Data.rotation = rotation.update(i);
    pause(0.01);
end

% Disable rotation
stream.Data.rotation = nan;